OpenTTD

- Main Page
- Related Pages
- Modules
- Namespaces
- Data Structures
- Files

- Data Structures
- Class Hierarchy
- Data Fields

Public Member Functions | Data Fields | Static Public Attributes
NWidgetNewGRFDisplay Class Reference

Custom nested widget container for the NewGRF gui. More...

Inheritance diagram for NWidgetNewGRFDisplay:

## Public Member Functions
| NWidgetNewGRFDisplay (NWidgetBase *avs, NWidgetBase *acs, NWidgetBase *inf)
virtual void | SetupSmallestSize (Window *w, bool init_array)
| Compute smallest size needed by the widget.
virtual void | AssignSizePosition (SizingType sizing, uint x, uint y, uint given_width, uint given_height, bool rtl)
| Assign size and position to the widget.
virtual NWidgetCore * | GetWidgetFromPos (int x, int y)
| Retrieve a widget by its position.
virtual void | Draw (const Window *w)
| Draw the widgets of the tree.
Public Member Functions inherited from NWidgetContainer
| NWidgetContainer (WidgetType tp)
| Constructor container baseclass.
void | Add (NWidgetBase *wid)
| Append widget wid to container.
void | FillNestedArray (NWidgetBase **array, uint length)
bool | IsEmpty ()
| Return whether the container is empty.
NWidgetBase * | GetWidgetOfType (WidgetType tp)
| Retrieve a widget by its type.
Public Member Functions inherited from NWidgetBase
| NWidgetBase (WidgetType tp)
| Base class constructor.
virtual bool | IsHighlighted () const
virtual TextColour | GetHighlightColour () const
virtual void | SetHighlighted (TextColour highlight_colour)
void | SetPadding (uint8 top, uint8 right, uint8 bottom, uint8 left)
| Set additional space (padding) around the widget.
uint | GetHorizontalStepSize (SizingType sizing) const
| Get the horizontal sizing step.
uint | GetVerticalStepSize (SizingType sizing) const
| Get the vertical sizing step.
virtual void | SetDirty (const Window *w) const
| Mark the widget as 'dirty' (in need of repaint).
Public Member Functions inherited from ZeroedMemoryAllocator
void * | operator new (size_t size)
| Memory allocator for a single class instance.
void * | operator new[] (size_t size)
| Memory allocator for an array of class instances.
void | operator delete (void *ptr)
| Memory release for a single class instance.
void | operator delete[] (void *ptr)
| Memory release for an array of class instances.

## Data Fields
NWidgetBase * | avs
| Widget with the available grfs list and buttons.
NWidgetBase * | acs
| Widget with the active grfs list and buttons.
NWidgetBase * | inf
| Info panel.
bool | editable
| Editable status of the parent NewGRF window (if `false`, drop all widgets that make the window editable).

## Static Public Attributes
static const uint | INTER_LIST_SPACING = WD_RESIZEBOX_WIDTH + 1
| Empty vertical space between both lists in the 2 column mode.
static const uint | INTER_COLUMN_SPACING = WD_RESIZEBOX_WIDTH
| Empty horizontal space between two columns.
static const uint | MAX_EXTRA_INFO_WIDTH = 150
| Maximal additional width given to the panel.
static const uint | MIN_EXTRA_FOR_3_COLUMNS = 50
| Minimal additional width needed before switching to 3 columns.

## Additional Inherited Members
Protected Member Functions inherited from NWidgetBase
void | StoreSizePosition (SizingType sizing, uint x, uint y, uint given_width, uint given_height)
| Store size and position.
Protected Attributes inherited from NWidgetContainer
NWidgetBase * | head
| Pointer to first widget in container.
NWidgetBase * | tail
| Pointer to last widget in container.

## Detailed Description

Custom nested widget container for the NewGRF gui.

Depending on the space in the gui, it uses either

- two column mode, put the acs and the avs underneath each other and the #info next to it, or
- three column mode, put the avs, acs, and #info each in its own column.

Definition at line 1590 of file newgrf_gui.cpp.

## Member Function Documentation

virtual void NWidgetNewGRFDisplay::AssignSizePosition | ( | SizingType | sizing,
|  | uint | x,
|  | uint | y,
|  | uint | given_width,
|  | uint | given_height,
|  | bool | rtl
| ) |  |
| inline virtual

Assign size and position to the widget.

Parameters

  sizing | Type of resizing to perform.
  x | Horizontal offset of the widget relative to the left edge of the window.
  y | Vertical offset of the widget relative to the top edge of the window.
  given_width | Width allocated to the widget.
  given_height | Height allocated to the widget.
  rtl | Adapt for right-to-left languages (position contents of horizontal containers backwards).

Afterwards, pos_x and pos_y contain the top-left position of the widget, smallest_x and smallest_y contain the smallest size such that all widgets of the window are consistent, and current_x and current_y contain the current size.

Implements NWidgetBase.

Definition at line 1658 of file newgrf_gui.cpp.

References ComputeMaxSize(), NewGRFParametersWindow::editable, max(), and min().

virtual void NWidgetNewGRFDisplay::Draw | ( | const Window * | w | ) |
| inline virtual

Draw the widgets of the tree.

The function calls Window::DrawWidget for each widget with a non-negative index, after the widget itself is painted.

Parameters

  w | Window that owns the tree.

Implements NWidgetBase.

Definition at line 1787 of file newgrf_gui.cpp.

References NWidgetBase::Draw(), and NewGRFParametersWindow::editable.

virtual NWidgetCore* NWidgetNewGRFDisplay::GetWidgetFromPos | ( | int | x,
|  | int | y
| ) |  |
| inline virtual

Retrieve a widget by its position.

Parameters

  x | Horizontal position relative to the left edge of the window.
  y | Vertical position relative to the top edge of the window.

Returns
  Returns the deepest nested widget that covers the given position, or `NULL` if no widget can be found.

Implements NWidgetBase.

Definition at line 1777 of file newgrf_gui.cpp.

References NewGRFParametersWindow::editable, NWidgetCore::GetWidgetFromPos(), and IsInsideBS().

virtual void NWidgetNewGRFDisplay::SetupSmallestSize | ( | Window * | w,
|  | bool | init_array
| ) |  |
| inline virtual

Compute smallest size needed by the widget.

The smallest size of a widget is the smallest size that a widget needs to display itself properly. In addition, filling and resizing of the widget are computed. The function calls Window::UpdateWidgetSize for each leaf widget and background widget without child with a non-negative index.

Parameters

  w | Window owning the widget.
  init_array | Initialize the `w->nested_array`.

Note
  After the computation, the results can be queried by accessing the smallest_x and smallest_y data members of the widget.

Implements NWidgetBase.

Definition at line 1615 of file newgrf_gui.cpp.

References ComputeMaxSize(), NewGRFParametersWindow::editable, NewGRFWindow::editable, LeastCommonMultiple(), and max().

The documentation for this class was generated from the following file:

- src/newgrf_gui.cpp